/*----------------------------------------------------------------
 * animator.h - definice typu animatoru
 *----------------------------------------------------------------
 */

#ifndef ANIMATOR_H_INCLUDED
#define ANIMATOR_H_INCLUDED

#include <allegro.h>

#define TYPE_ANIMATION_COUNT 40

//definice druhu pohybu
#define ANIMATION_DEFAULT 0 // defaultni animace, napr. kdyz nejsou dane animace 
#define ANIMATION_STAY 0    //otoceni asi k obrazovce, jinak upravit
#define ANIMATION_DEAD 1

#define ANIMATION_WALK_N  2
#define ANIMATION_WALK_NE 3
#define ANIMATION_WALK_E  4
#define ANIMATION_WALK_SE 5
#define ANIMATION_WALK_S  6
#define ANIMATION_WALK_SW 7
#define ANIMATION_WALK_W  8
#define ANIMATION_WALK_NW 9

#define ANIMATION_RUN_N  10
#define ANIMATION_RUN_NE 11
#define ANIMATION_RUN_E  12
#define ANIMATION_RUN_SE 13
#define ANIMATION_RUN_S  14
#define ANIMATION_RUN_SW 15
#define ANIMATION_RUN_W  16
#define ANIMATION_RUN_NW 17

#define ANIMATION_ACTION_N  18
#define ANIMATION_ACTION_NE 19
#define ANIMATION_ACTION_E  20
#define ANIMATION_ACTION_SE 21
#define ANIMATION_ACTION_S  22
#define ANIMATION_ACTION_SW 23
#define ANIMATION_ACTION_W  24
#define ANIMATION_ACTION_NW 25

// struktura jednoho framu
typedef struct {
  int image;            // cislo obrazku
  int image_position_X;	// pozice framu v obrazku X
  int image_position_Y;	// pozice framu v obrazku Y
  int width, height;	// sirka a vyska obrazku (dx, dy)
  int move_X, move_Y;	// posun vuci originalu
} ONE_FRAME_STRUCTURE;


// struktura pole frejmu
typedef struct {
  int delay;
  int index;
} FRAME_STRUCTURE;

// struktura animace
typedef struct {
  int count;
  int loop_start;   // na kterou animaci skoci pri dohrani loopu
  FRAME_STRUCTURE *frame;
} ANIMATION_STRUCTURE;

// struktura animovaneho objektu
typedef struct {
  long last_time; // kdyz byl aposledni animace
  int actual_frame;
  int actual_animation;
  ANIMATION_STRUCTURE animation[TYPE_ANIMATION_COUNT];
  ONE_FRAME_STRUCTURE *frame;
  BITMAP **image;   //JE ZMENENE
  int bitmap_count; // pocet bitmap, pro destrukci anim_objektu
} ANIM_OBJECT_STRUCTURE;


ANIM_OBJECT_STRUCTURE *load_anim_object(char *name);
int draw_anim_object(ANIM_OBJECT_STRUCTURE *anim_object, int x, int y);
int fr_draw_anim_object(ANIM_OBJECT_STRUCTURE *anim_object, int x, int y, int animation, int frame);
int fr_draw_anim_object2(ANIM_OBJECT_STRUCTURE *anim_object, int x, int y, int animation, int frame);
int draw_center_top(ANIM_OBJECT_STRUCTURE *anim_object, int x, int y, int animation, int frame);
int draw_center_bottom(ANIM_OBJECT_STRUCTURE *anim_object, int x, int y, int animation, int frame);
int get_animation(ANIM_OBJECT_STRUCTURE *anim_object);
int set_animation(ANIM_OBJECT_STRUCTURE *anim_object, int animation);
int change_animation(ANIM_OBJECT_STRUCTURE *anim_object, int animation);
int stop_animation(ANIM_OBJECT_STRUCTURE *anim_object);
int destroy_anim_object(ANIM_OBJECT_STRUCTURE *anim_object);
int animate_anim_object(ANIM_OBJECT_STRUCTURE *anim_object);
int is_here(ANIM_OBJECT_STRUCTURE *anim_object, int draw_x, int draw_y);



#endif // ANIMATOR_H_INCLUDED
